config/routes.rb
Rails.application.routes.draw do
root "home#index"
  devise_for :users
  resources :home
  resources :contact
  resources :about
  resources :posts do
    resources :comments
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :post
  has_rich_text :content
end

app/models/model.rb
class Model < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/models/post.rb
class Post < ApplicationRecord
    has_many :comments
    has_rich_text :content
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/about_controller.rb
class AboutController < ApplicationController
    def index
    end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
    before_action :authenticate_user!
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  before_action :set_comment, only: %i[ show edit update destroy ]

  # GET /comments or /comments.json
  def index
    @comments = Comment.all
  end

  # GET /comments/1 or /comments/1.json
  def show
  end

  # GET /comments/new
  def new
    @comment = Comment.new
  end

  # GET /comments/1/edit
  def edit
  end

  # POST /comments or /comments.json
  def create
    @comment = Comment.new(comment_params)
    @comment.post_id = params[:post_id]

    respond_to do |format|
      if @comment.save
        format.html { redirect_to post_url(@comment.post), notice: "Comment was successfully created." }
        format.json { render :show, status: :created, location: @comment }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @comment.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /comments/1 or /comments/1.json
  def update
    respond_to do |format|
      if @comment.update(comment_params)
        format.html { redirect_to comment_url(@comment), notice: "Comment was successfully updated." }
        format.json { render :show, status: :ok, location: @comment }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @comment.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /comments/1 or /comments/1.json
  def destroy
    @comment.destroy

    respond_to do |format|
      format.html { redirect_to post_url(@comment.post), notice: "Comment was successfully destroyed." }
      format.json { head :no_content }
    end
  end


  private
    # Use callbacks to share common setup or constraints between actions.
    def set_comment
      @comment = Comment.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def comment_params
      params.require(:comment).permit(:post_id, :content)
    end
end

app/controllers/contact_controller.rb
class ContactController < ApplicationController
    def index
    end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
    def index
    end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :set_post, only: %i[ show edit update destroy ]

  # GET /posts or /posts.json
  def index
    @posts = Post.all
  end

  # GET /posts/1 or /posts/1.json
  def show
  end

  # GET /posts/new
  def new
    @post = Post.new
  end

  # GET /posts/1/edit
  def edit
  end

  # POST /posts or /posts.json
  def create
    @post = Post.new(post_params)

    respond_to do |format|
      if @post.save
        PostMailer.with(user: current_user, post: @post).post_created.deliver_later
        format.html { redirect_to post_url(@post), notice: "Post was successfully created." }
        format.json { render :show, status: :created, location: @post }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /posts/1 or /posts/1.json
  def update
    respond_to do |format|
      if @post.update(post_params)
        format.html { redirect_to post_url(@post), notice: "Post was successfully updated." }
        format.json { render :show, status: :ok, location: @post }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /posts/1 or /posts/1.json
  def destroy
    @post.destroy

    respond_to do |format|
      format.html { redirect_to posts_url, notice: "Post was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_post
      @post = Post.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def post_params
      params.require(:post).permit(:title, :content)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/views/about/index.html.erb
<section class="hero is-small is-info">
  <div class="hero-body">
    <p class="title">
      This is the About Page
    </p>
    <p class="subtitle">
      More stuff to follow here later
    </p>
  </div>
</section>

app/views/active_storage/blobs/_blob.html.erb
<figure class="attachment attachment--<%= blob.representable? ? "preview" : "file" %> attachment--<%= blob.filename.extension %>">
  <% if blob.representable? %>
    <%= image_tag blob.representation(resize_to_limit: local_assigns[:in_gallery] ? [ 800, 600 ] : [ 1024, 768 ]) %>
  <% end %>

  <figcaption class="attachment__caption">
    <% if caption = blob.try(:caption) %>
      <%= caption %>
    <% else %>
      <span class="attachment__name"><%= blob.filename %></span>
      <span class="attachment__size"><%= number_to_human_size blob.byte_size %></span>
    <% end %>
  </figcaption>
</figure>

app/views/comments/_comment.html.erb
<div id="<%= dom_id comment %>">
  <p>
    <strong>Body:</strong>
    <%= comment.body %>
  </p>

  <p>
    <strong>Post:</strong>
    <%= comment.post_id %>
  </p>

</div>

app/views/comments/_form.html.erb
<%= form_with(model: comment, url: the_url) do |form| %>
  <% if comment.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(comment.errors.count, "error") %> prohibited this comment from being saved:</h2>
      <ul>
        <% comment.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :body, class: "label" %>
    <div class="control">
      <%= form.rich_text_area :content %>
    </div>
  </div>

  <div>
    <%= form.submit class: "button is-success mt-2" %>
  </div>
<% end %>

app/views/comments/edit.html.erb
<h1 class="title has-text-success">Edit comment</h1>

<%= render "form", comment: @comment, the_url: post_comment_path(@comment.post, @comment) %>

<br>

<div>
  <%= link_to "Back to the post", post_url(@comment.post) %>
</div>

app/views/comments/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Comments</h1>

<div id="comments">
  <% @comments.each do |comment| %>
    <%= render comment %>
    <p>
      <%= link_to "Show this comment", comment %>
    </p>
  <% end %>
</div>

<%= link_to "New comment", new_comment_path %>

app/views/comments/new.html.erb
<h2 class="subtitle has-text-weight-semibold has-text-success">New comment</h2>

<%= render "form", comment: @comment %>

<br>

<div>
  <%= link_to "Back to the post", post_url(@comment.post) %>
</div>

app/views/comments/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @comment %>

<div>
  <%= link_to "Edit this comment", edit_comment_path(@comment) %> |
  <%= link_to "Back to comments", comments_path %>

  <%= button_to "Destroy this comment", @comment, method: :delete %>
</div>

app/views/contact/index.html.erb
<h1>Contact Page </h1>

app/views/home/index.html.erb
<section class="hero is-small is-link">
  <div class="hero-body">
    <p class="title">
      This is the Home Page
    </p>
    <p class="subtitle">
      More stuff to follow here later
    </p>
  </div>
</section>

app/views/layouts/_footer.html.erb
<footer class="footer">
  <div class="content has-text-centered">
    <p>
      Tiny Rails Footer still needs text
    </p>
  </div>
</footer>

app/views/layouts/_header.html.erb
<nav class="navbar is-light" role="navigation" aria-label="main navigation">
  <div class="navbar-brand">
    <a class="navbar-item" href="/home">
      <img src="https://hisgames.org/images/logo/214/logo_tiny-rails.png" width="112" height="28">
    </a>

    <a role="button" class="navbar-burger" aria-label="menu" aria-expanded="false" data-target="navbarBasicExample">
      <span aria-hidden="true"></span>
      <span aria-hidden="true"></span>
      <span aria-hidden="true"></span>
    </a>
  </div>

  <div id="navbarBasicExample" class="navbar-menu">
    <div class="navbar-start">
      <a class="navbar-item">
        <%= link_to 'Home', home_index_url, class:'navbar-item' %>
      </a>
      
      
      <a class="navbar-item">
        <%= link_to 'Posts', posts_url, class:'navbar-item' %>
      </a>
      
      
      <a class="navbar-item">
        <%= link_to 'About', about_index_url, class:'navbar-item' %>
      </a>

      </div>
    </div>


    <div class="navbar-end">
      <div class="navbar-item">
        <div class="buttons">
          <% if current_user %>
        <%= current_user.email %> 
        <div id='post spacer' style="width: 20px;"></div>
          <%= button_to "Logout", destroy_user_session_path, method: :delete, data: { turbo: false }, class: "button is-danger"  %>
          
          <% else %>
            Not logged in
          <% end %>

          </a>
        </div>
      </div>
    </div>
  </div>
</nav>

app/views/layouts/action_text/contents/_content.html.erb
<div class="trix-content">
  <%= yield -%>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Tiny Rails app</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.9.3/css/bulma.min.css">
    <%= javascript_importmap_tags %>
    <%= render partial: "/layouts/header" %>
  </head>

  <body>
   <p class="notice"><%= notice %></p>
   <p class="alert"><%= alert %></p>

   <section class="section">
   <div class="container">
   <%= yield %> 
    </div>
  </section>

  </body>
  <footer>
    <%= render partial: "/layouts/footer" %>
  </footer>
</html>

app/views/posts/_form.html.erb
<%= form_with(model: post) do |form| %>
  <% if post.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(post.errors.count, "error") %> prohibited this post from being saved:</h2>

      <ul>
        <% post.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  
  <div class="field">
    <label class="label">Title</label>
    <div class="control">
      <%= form.text_field :title, class: "input" %>
    </div>
  </div>

  <div class="field">
    <%= form.label :body, class: "label" %>
    <div class="control" style="min-height:13em;">
      <%= form.rich_text_area :content %>
    </div>
  </div>

  <div>
    <%= form.submit class: "button is-success mb-2" %>
  </div>



<% end %>

app/views/posts/_post.html.erb
<div id="<%= dom_id post %>">
  <div class="container mb-2"><h2 class="title">
    <%= post.title %></h2>
  </div>
   <article class="media">
    <figure class="media-left">
      <p class="image is-64x64">
        <img src="https://bulma.io/images/placeholders/128x128.png">
      </p>
  </figure>
  <div class="media-content">
    <div class="content">
    <p>
    <%= post.title %>
    <br>
      <%= post.content %>
    </p>

</div>
    <nav class="level is-mobile">
      <div class="level-left">
        <a class="level-item">
          <span class="icon is-small"><i class="fas fa-reply"></i></span>
        </a>
        <a class="level-item">
          <span class="icon is-small"><i class="fas fa-retweet"></i></span>
        </a>
        <a class="level-item">
          <span class="icon is-small"><i class="fas fa-heart"></i></span>
        </a>
      </div>
    </nav>
  </div>
</article>

app/views/posts/edit.html.erb
<h1>Editing post</h1>

<%= render "form", post: @post %>

<br>

<div>
  <%= link_to "Show this post", @post %> |
  <%= link_to "Back to posts", posts_path %>
</div>

app/views/posts/index.html.erb
<p style="color: green"><%= notice %></p>

<section class="hero is-small is-primary">
  <div class="hero-body">
    <p class="title">
      Blog Posts
    </p>
    <p class="subtitle">
      Follow my blog
    </p>
  </div>
</section>

<div id='post spacer' style="height: 30px;"></div>


<div id="posts">
  <% @posts.each do |post| %>
    <%= render post %>
    <p>
      <%= link_to "Show this post", post, class:"button is-info" %>
    </p>
  <div id='post spacer' style="height: 10px;"></div>
  <% end %>
</div>
<div id='new post spacer' style="height: 10px;"></div>
<%= link_to "New post", new_post_path, class:"button is-primary" %>

app/views/posts/new.html.erb
<h1>New post</h1>

<%= render "form", post: @post %>

<br>

<div>
  <%= link_to "Back to posts", posts_path %>
</div>

app/views/posts/show.html.erb
<p style="color: green"><%= notice %></p>
<div class="post mb-0">
<%= render @post %>
</div>

<div>
    <%= button_to "Delete", @post, method: :delete, class: "button is-small is-danger mt-1" %>
    <%= link_to " Edit post", edit_post_path(@post), class: "button is-small is-success mt-1" %>
</div>

<div class="comments container pt-0">
  <hr>
  <% if current_user %>
  <div class="comment create">
    <h2 class="subtitle has-text-weight-semibold has-text-success">Leave a comment</h2>
  
    <%= render "comments/form", comment: @post.comments.new, the_url: post_comments_path(@post) %>
  </div>
  <% else %>
  <h2 class="subtitle has-text-weight-semibold has-text-success"><a href="/users/sign_in" class="has-text-success">Log in</a> to leave a comment</h2>
  <% end %>
  <div class="comment-list container mt-5">
    <h2 class="subtitle has-text-weight-bold"><%= pluralize(@post.comments.count, "Comment") %> </h2>
    <% @post.comments.where("id > 0").each do |comment| %>

    <article class="media">
      <figure class="media-left">
        <p class="image is-64x64">
        <img src="https://bulma.io/images/placeholders/128x128.png">
      </p>
        <%= button_to "Delete", post_comment_path(@post, comment), method: :delete, class: "button is-small is-danger mt-1" %>
        <%= link_to "Edit", edit_post_comment_path(@post, comment), class: "button is-small is-success mt-1" %>

        </p>
      </figure>
        <div class="container mt-2">
          <%= comment.content %>
        </div>

      </div>
    </article>
  <% end %>